package guanlixitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong"
	"shylinux.com/x/enterprise/src/guanlixitong/model"
)

type Tables struct {
	gonganxitong.Tables
	list string `name:"list group_uid uid auto" role:"void"`
}
type Table struct {
	gonganxitong.Table
	list string `name:"list group_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.GROUP_TYPE:
		for k, v := range GroupTypeList {
			m.Push(arg[0], k).Push(model.NAME, v)
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	case model.USER_GROUP_ROLE:
		for k, v := range UserGroupRoleList {
			if k != UserGroupCreator && k != UserGroupVisitor {
				m.Push(arg[0], k).Push(model.NAME, v)
			}
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		kit.If(key == model.GROUP_TYPE, func() { value = GroupType(kit.Int(value)).String() })
		kit.If(key == model.USER_GROUP_ROLE, func() { value = UserGroupRole(kit.Int(value)).String() })
		return value
	})
	s.Table.RewriteAppend(m)
	return m
}
func (s Table) SelectJoinCompany(m *ice.Message) *ice.Message {
	return s.SelectJoin(m, company{}, model.NAME, model.CITY_UID)
}
